#********************************
# Implementor: Raghvendra Rohit
# Contact: rsrohit@uwaterloo.ca 
#********************************

import os
from wage import wage

def solve(rnd, ft, sut, mid, nw):
	C = wage(rnd,ft, sut, mid, nw)
	C.make_model()
	obj = C.solve_model()
	comm1 = "rm wage_"+str(rnd)+".lp"
	comm2 = "rm wage_binary"+str(rnd)+".txt"
	os.system(comm1)
	os.system(comm2)

	return obj

if __name__ == "__main__":
	
	nw = 37 										# number of 7-bit words of WAGE
	sut = [[8,5], [15,11], [27,24], [34,30]]		# SB sboxes input/output taps
	mid = 18										# Middle WGP input tap
	ft = [36, 31, 30, 26, 24, 19, 13, 12, 8, 6, 0]	# Feedback taps
	
	fp = open("WAGE_min_sboxes.txt", "a")
	
	for rounds in range(49,50):
		sol = solve(rounds, ft, sut, mid, nw)
		fp.write(str(rounds) + "\t" + str(sol) + "\n")

	fp.close()